$debug
c
c     Automatic interpretation of vertical magnetic gradient
c        measurements  -  DYKE  solutions
c
      implicit real*8 (a-h,o-z)
      integer ispan(10)
      real*8 x(25),z(25),vg(800),amag(800)
     &,xl(800),pos(800),depth(800),dip(800),th(800)
      common/param/d,t,dep,alpha,susc,phi,xncl,decl,theta,h,rad,iok
c
c     dyke solution - npt = 10
c
      npt=10
      rad=1./57.29578
c
c     h    = total field magnitude (nT)
c     ainc =   "     "   inclination (degrees) in plane of profile
c     str  = angle between profile strike and magnetic north (degrees)
c     isp  = number of spans used
c     tol = tolerance distance (metres)
c     ispan(i) = span used for run i
c
      read(1,*) h,ainc,str
      read(1,*)isp,tol
      read(1,*)(ispan(i),i=1,isp)
  50  format(5f10.3)
      write(2,8)
   8  format('0   totf       inc      str     tol ')
      write(2,50)h,ainc,str,tol
      xncl=ainc*rad
      decl=str*rad
      if(ainc.gt.89.5)then
      phi=xncl
      else
      phi=datan(dtan(xncl)/dcos(decl))
      endif
60    ktot=1
61    read (1,*,end=199) xl(ktot),vg(ktot)
      ktot=ktot+1
      go to 61
199   do100is=1,isp
      iok=0
      do4i=1,ktot-1-ispan(is)*(npt-1)
c solve for npt window
      do5j=1,npt
      x(j)=xl(i+(j-1)*ispan(is))
  5   z(j)=vg(i+(j-1)*ispan(is))
      call dyke(x,z,npt)
c reject solutions if depth or thickness < 0
      if(dep.gt.0.0)then
      if(t.gt.0.0)then
      if(theta.gt.0.0.and.theta.lt.180.0)then
c store acceptable solutions
      depth(iok)=dep
      dip(iok)=theta
      pos(iok)=d
      amag(iok)=susc
      th(iok)=t
      endif
      endif
      endif
   4  continue
c keep successive solutions if distance in x and z directions
c less than distance TOL. Setting TOL equal to average data spacing
c usually works.
      k=1
      inew=1
      xp=pos(1)
      yp=depth(1)
      do9j=2,iok
      xx=pos(j)
      yy=depth(j)
      if(dabs(xx-xp).lt.tol.and.dabs(yy-yp).lt.tol)then
        if(inew.eq.1)then
          pos(k)=xp
          depth(k)=yp
          dip(k)=dip(j-1)
          amag(k)=amag(j-1)
          th(k)=th(j-1)
          k=k+1
          inew=0
        endif
        pos(k)=xx
        depth(k)=yy
        dip(k)=dip(j)
        amag(k)=amag(j)
        th(k)=th(j)
        k=k+1
      else
        inew=1
      endif
      xp=xx
  9   yp=yy
      k=k-1
      write(2,62)k,ispan(is)
  62  format(' # of solutions ',i5,' for span',i3)
      write(2,63)(pos(i),depth(i),dip(i),th(i),amag(i),i=1,k)
  63  format(4f12.3,g12.3)
 100  continue
 999  stop
      end
      subroutine dyke (x,z,npts)
c solve for dyke parameters from npts window
      implicit real*8 (a-h,o-z)
      dimension  x(10),z(10),a(10,10),dp(10),indx(10)
      common/param/d,t,dep,alpha,susc,phi,xncl,decl,theta,h,rad,iok
      np=npts
c reference x values to this point. Using true x values results
c in poor conditioning of matrix equations.
      x5=x(5)
      do 150 i=1,npts
150   x(i)=x(i)-x5
c set up matrix equations (19)
c figure in parenthesis refer to equations in Keating and Pilkington (1990)
      do 200 i=1,npts
      xi=x(i)
      zi=z(i)
      xi2=xi*xi
      xi3=xi2*xi
      xi4=xi3*xi
      a(i,1)=xi3*zi
      a(i,2)=xi2*zi
      a(i,3)=xi*zi
      a(i,4)=zi
      a(i,5)=xi2
      a(i,6)=xi
      a(i,7)=1.0
      a(i,8)=xi4
      a(i,9)=xi3
      a(i,10)=xi4*xi
      dp(i)=-xi4*zi
c both sides of (19) scaled to improve conditioning
      wi=zi**2
      do 250 j=1,10
      a(i,j)=a(i,j)*wi
250   continue
      dp(i)=dp(i)*wi
200   continue
c solve matrix equations
      call ludcmp(a,npts,np,indx,x)
      call lubksb(a,npts,np,indx,dp)
c (20)
      g1=dp(10)
c (20)
      g0=(dp(8)-dp(1)*g1)
c (11)
      d=-dp(1)/4.
      d2=d**2
c solve (12)
      b=2.*((6.*d2)-dp(2))
      c=2.*d2*(2*d2-dp(2))+((dp(2)/2.)**2)-dp(4)
      dep=b**2-16.*c
      if(dep.lt.0.) return
      dep=dsqrt(dep)
      t=(-b+dep)/8.
      if(t.lt.0.) return
      dep=dsqrt(t)
c (5)
      t=t+3.*d2-dp(2)/2.
      if(t.le.0.) return
      t=dsqrt(t)
c (18,20)
      dp(5)=dp(5)-g0*dp(2)-dp(3)*g1
      dp(6)=dp(6)-g0*dp(3)-dp(4)*g1
c (13)
      aa=dp(5)/t
c (14)
      b=(2.*t*aa*d+dp(6))/(2.*t*dep)
c (15)
      alpha=datan2(aa,b)
      theta=2.*phi-alpha
      susc=aa/(4.*h*dsin(alpha)*dsin(theta)*(dsin(xncl)/dsin(phi))**2)
      theta=theta/rad
      if(theta.lt.0.0.or.theta.gt.180.0)return
c add back reference distance
      d=d+x5
      alpha=alpha/rad
      iok=iok+1
      return
      end
      subroutine ludcmp(a,n,np,indx,d)
      implicit real*8 (a-h,o-z)
      parameter (nmax=100,tiny=1.0d-20)
      dimension a(np,np),indx(n),vv(nmax)
      d=1.
      do 12 i=1,n
        aamax=0.
        do 11 j=1,n
          if (dabs(a(i,j)).gt.aamax) aamax=dabs(a(i,j))
11      continue
        if (aamax.eq.0.) pause 'singular matrix.'
        vv(i)=1./aamax
12    continue
      do 19 j=1,n
        if (j.gt.1) then
          do 14 i=1,j-1
            sum=a(i,j)
            if (i.gt.1)then
              do 13 k=1,i-1
                sum=sum-a(i,k)*a(k,j)
13            continue
              a(i,j)=sum
            endif
14        continue
        endif
        aamax=0.
        do 16 i=j,n
          sum=a(i,j)
          if (j.gt.1)then
            do 15 k=1,j-1
              sum=sum-a(i,k)*a(k,j)
15          continue
            a(i,j)=sum
          endif
          dum=vv(i)*dabs(sum)
          if (dum.ge.aamax) then
            imax=i
            aamax=dum
          endif
16      continue
        if (j.ne.imax)then
          do 17 k=1,n
            dum=a(imax,k)
            a(imax,k)=a(j,k)
            a(j,k)=dum
17        continue
          d=-d
          vv(imax)=vv(j)
        endif
        indx(j)=imax
        if(j.ne.n)then
          if(a(j,j).eq.0.)a(j,j)=tiny
          dum=1./a(j,j)
          do 18 i=j+1,n
            a(i,j)=a(i,j)*dum
18        continue
        endif
19    continue
      if(a(n,n).eq.0.)a(n,n)=tiny
      return
      end
      subroutine lubksb(a,n,np,indx,b)
      implicit real*8 (a-h,o-z)
      dimension a(np,np),indx(n),b(n)
      ii=0
      do 12 i=1,n
        ll=indx(i)
        sum=b(ll)
        b(ll)=b(i)
        if (ii.ne.0)then
          do 11 j=ii,i-1
            sum=sum-a(i,j)*b(j)
11        continue
        else if (sum.ne.0.) then
          ii=i
        endif
        b(i)=sum
12    continue
      do 14 i=n,1,-1
        sum=b(i)
        if(i.lt.n)then
          do 13 j=i+1,n
            sum=sum-a(i,j)*b(j)
13        continue
        endif
        b(i)=sum/a(i,i)
14    continue
      return
      end

